<template>
    <div class="app-container">
        <!--    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">-->
        <!--      <el-form-item label="标题" prop="title">-->
        <!--        <el-input-->
        <!--          v-model="queryParams.title"-->
        <!--          placeholder="请输入标题"-->
        <!--          clearable-->
        <!--          @keyup.enter.native="handleQuery"-->
        <!--        />-->
        <!--      </el-form-item>-->
        <!--      <el-form-item>-->
        <!--        <el-button type="primary" icon="el-icon-search"   @click="handleQuery">搜索</el-button>-->
        <!--        <el-button icon="el-icon-refresh"   @click="resetQuery">重置</el-button>-->
        <!--      </el-form-item>-->
        <!--    </el-form>-->

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['activity:rechargeInfo:add']">新增</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="success" plain icon="el-icon-edit" :disabled="single" @click="handleUpdate" v-hasPermi="['activity:rechargeInfo:edit']">修改</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="danger" plain icon="el-icon-delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['activity:rechargeInfo:edit']">删除</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/activity/rechargeItem/list" :request-params="queryParams" ref="pagination">
            <el-table-column type="selection" width="55" align="center" fixed="left" />
            <el-table-column label="序号" align="center" prop="id" width="80" />
            <el-table-column label="充值选项" align="center" prop="rechargeTypeTitle" />
            <el-table-column label="充值金额（元）" align="center" prop="rechargeAmount" width="150" />
            <el-table-column label="原赠送金额（元）" align="center" prop="giveAmount" width="150" />
            <el-table-column label="活动增送金额（元）" align="center" prop="activityGiveAmount" width="150" />
            <el-table-column label="创建人" align="center" prop="createBy" />
            <el-table-column label="创建时间" align="center" prop="createTime" />
            <el-table-column label="修改人" align="center" prop="updateBy" />
            <el-table-column label="修改时间" align="center" prop="createTime" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="200">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['activity:rechargeInfo:edit']">修改</el-button>
                    <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['activity:rechargeInfo:edit']">删除</el-button>
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改充值多送活动明细对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="40%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="150px">
                    <el-col :span="24">
                        <el-form-item label="充值选项" prop="rechargeTypeId">
                            <el-select v-model="form.rechargeTypeId" placeholder="请选择充值选项" :style="{ width: '100%' }">
                                <el-option v-for="item in rechargeTypes" :label="item.title" :value="item.id" :key="item.title"> </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="活动赠送金额（元）" prop="activityGiveAmount">
                            <el-input-number v-model="form.activityGiveAmount" placeholder="请输入活动赠送金额" :precision="2" :min="0" :max="999999" />
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listRechargeItem, getRechargeItem, delRechargeItem, addRechargeItem, updateRechargeItem, updateRechargeItemStatus } from '@/api/activity/rechargeItem'
import { allList } from '@/api/recharge/type'
export default {
    name: 'RechargeItem',
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 充值多送活动明细表格数据
            rechargeItemList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {},
            // 表单参数
            form: {},
            // 表单校验
            rules: {},
            rechargeTypes: []
        }
    },
    created() {
        this.activityId = this.$route.params && this.$route.params.activityId
        allList().then((res) => {
            this.rechargeTypes = res.data
        })
        this.getList()
    },
    methods: {
        /** 查询充值多送活动明细列表 */
        getList() {
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                activityId: null,
                rechargeTypeId: null,
                activityGiveAmount: null,
                delFlag: null,
                createById: null,
                createBy: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null,
                remark: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加充值多送活动明细'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getRechargeItem(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改充值多送活动明细'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateRechargeItem({ ...this.form, ...{ activityId: this.activityId } }).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addRechargeItem({ ...this.form, ...{ activityId: this.activityId } }).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除充值多送活动明细编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delRechargeItem(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/activity/rechargeItem/export',
                {
                    ...this.queryParams
                },
                `rechargeItem_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        }
    }
}
</script>
